      subroutine arrange_3d_1(FFT3D, F_TMP, hkl_min, hkl_max)

C     Rearranges elements of 3D FT into 1D structure in preparation for 
C     parallel computation

      implicit none
      include '../include/allprogs.inc'
 
      integer, intent(in) :: hkl_min, hkl_max
      complex, intent(in) :: FFT3D(0:hkl_max, hkl_min:hkl_max, 
     +               frst_lst_y(1,iam):frst_lst_y(2,iam))

      complex, intent(out) :: F_TMP((hkl_max+1)*(hkl_max-hkl_min+1)*
     +     (frst_lst_y(2,iam)-frst_lst_y(1,iam)+1))

      integer i, j, k, z, recv
        
      recv = 0
      do i = 0, num_nodes -1 
         do z = frst_lst_y(1,iam), frst_lst_y(2,iam)
            do k = hkl_min, hkl_max
               do j = frst_lst_iq(1,i), frst_lst_iq(2,i)
                  recv = recv + 1
                  F_TMP(recv) = FFT3D(j,k,z)
               enddo
            enddo
         enddo
      enddo

      return
      end subroutine arrange_3d_1
